-- Ignore some luacheck warnings about global vars, just use a ton of them in WoW Lua
-- luacheck: no global
-- luacheck: no self
local _, ElementalOverload = ...

ElementalOverload = LibStub("AceAddon-3.0"):NewAddon(ElementalOverload, "ElementalOverload", "AceConsole-3.0", "AceEvent-3.0")
LibRealmInfo = LibStub("LibRealmInfo")

local spell = GetSpellInfo(390392)

-- Set up DataBroker for minimap button
SimcLDB = LibStub("LibDataBroker-1.1"):NewDataObject("ElementalOverload", {
  type = "data source",
  text = "ElementalOverload",
  label = "ElementalOverload",
  icon = "Interface\\AddOns\\ElementalOverload\\logo",
  OnClick = function()
    if ElementalOverload.eleframe and ElementalOverload.eleframe:IsShown() then
		ElementalOverload.eleframe:Hide()
		ElementalOverload.apenabled = 0
		ElementalOverloadEnabled = 0
    else
		ElementalOverload.eleframe:Show()
		ElementalOverload.apenabled = 1
		ElementalOverloadEnabled = 1
		ElementalOverload:ShowOverload(ElementalOverload.eleframe)
      --Simulationcraft:PrintSimcProfile(false, false, false)
    end
  end,
  OnTooltipShow = function(tt)
    tt:AddLine("Elemental Overload")
    tt:AddLine(" ")
    tt:AddLine("Click to show Elemental Overload")
  end
})

LibDBIcon = LibStub("LibDBIcon-1.0")

ElementalOverload.apenabled = 1
ElementalOverload.aplocked = 1

local animaSpellID = { [347555] = 3, [345706] = 5, [336327] = 35, [336456] = 250 }

local elementalItemArray = 
{
	['air'] = { rousing = { id = 190326, count = 0 }, awakened = { id = 190327, count = 0 }, row = 1 },
	['frost'] = { rousing = { id = 190328, count = 0 }, awakened = { id = 190329, count = 0 }, row = 2 },
	['earth'] = { rousing = { id = 190315, count = 0 }, awakened = { id = 190316, count = 0 }, row = 3 },
	['fire'] = { rousing = { id = 190320, count = 0 }, awakened = { id = 190321, count = 0 }, row = 4 },
	['order'] = { rousing = { id = 190322, count = 0 }, awakened = { id = 190324, count = 0 }, row = 5  },
	['decay'] = { rousing = { id = 190330, count = 0 }, awakened = { id = 190331, count = 0 }, row = 6 },
	['ire'] = { rousing = { id = 190451, count = 0 }, awakened = { id = 190450, count = 0 }, row = 7 }
}

local function countAnima()
    --local c = 0

	for tspellid, elementalitem in pairs(elementalItemArray) do					


			elementalitem.rousing.count = 0
			elementalitem.awakened.count = 0

	end

    for bag=0,12 do
        for slot=1,C_Container.GetContainerNumSlots(bag) do

			local containerinfo = C_Container.GetContainerItemInfo(bag, slot)

			if containerinfo ~= nil then

				for tspellid, elementalitem in pairs(elementalItemArray) do					

					if elementalitem.rousing.id == containerinfo.itemID then
						elementalitem.rousing.count = elementalitem.rousing.count + containerinfo.stackCount
					end
					if elementalitem.awakened.id == containerinfo.itemID then
						elementalitem.awakened.count = elementalitem.awakened.count + containerinfo.stackCount
					end
				end

			end 
        end
    end

	for slot=1,C_Container.GetContainerNumSlots(-3) do

		local containerinfo = C_Container.GetContainerItemInfo(-3, slot)

		if containerinfo ~= nil then

			for tspellid, elementalitem in pairs(elementalItemArray) do					

				if elementalitem.rousing.id == containerinfo.itemID then
					elementalitem.rousing.count = elementalitem.rousing.count + containerinfo.stackCount
				end
				if elementalitem.awakened.id == containerinfo.itemID then
					elementalitem.awakened.count = elementalitem.awakened.count + containerinfo.stackCount
				end
			end

		end 
	end

    --return c
end

function ElementalOverload:ShowOverload(self)

	self.text:SetPoint("TOP", 0, -4)
	self.text:SetText("Elemental Overload")

	if ElementalOverload.apenabled == 0 then
		self:Hide()
		return
	end

    --getTarragrueAnimaPowers()

	-- if apnotready == 1 then
	-- 	self:Hide()
	-- 	return
	-- end

	countAnima()

	for tspellid, animaobject in pairs(elementalItemArray) do

		if tspellid == nil then
			return
		end

		animaobject.rousing.frame.text:SetText("")
		animaobject.awakened.frame.text:SetText("")

		if animaobject.rousing.count > 0 then
			animaobject.rousing.frame.text:SetText(format("%d", animaobject.rousing.count))
		end
		if animaobject.awakened.count > 0 then
			animaobject.awakened.frame.text:SetText(format("%d", animaobject.awakened.count))
		end
	end


	self:Show()
end


local eleframe = CreateFrame("StatusBar", "InaELeOverloadFrame", UIParent, BackdropTemplateMixin and "BackdropTemplate")

local lockbutton = CreateFrame("Button", "MyButton", eleframe, "UIPanelButtonTemplate")
lockbutton:SetSize(16 ,16) -- width, height
lockbutton:SetPoint("TOPRIGHT", -4, -4) 
--lockbutton:SetText("L")
lockbutton:SetPoint("CENTER")
lockbutton:SetAlpha(0.3)
lockbutton:SetNormalTexture("Interface\\Addons\\ElementalOverload\\images\\locked")
lockbutton:SetScript("OnClick", function()
    if ElementalOverload.aplocked == 0 then
		ElementalOverload.aplocked = 1
		eleframe:EnableMouse(false)
		lockbutton:SetNormalTexture("Interface\\Addons\\ElementalOverload\\images\\locked")
		lockbutton:SetAlpha(0.3)
	else
		ElementalOverload.aplocked = 0
		eleframe:EnableMouse(true)
		lockbutton:SetNormalTexture("Interface\\Addons\\ElementalOverload\\images\\unlocked")
		lockbutton:SetAlpha(0.8)
	end
end)


ElementalOverload.eleframe  = eleframe

eleframe:SetSize(32 * 8, 108)

if (eleframe:GetTop() == nil) then
	eleframe:SetPoint("TOP")
end

eleframe:SetBackdrop({bgFile = [[Interface\ChatFrame\ChatFrameBackground]]})
eleframe:SetBackdropColor(0, 0, 0, 0.7)
--eleframe:SetStatusBarTexture([[Interface\Addons\ElementalOverload\textures\Minimalist]])
--eleframe:SetStatusBarColor(0, 0.5, 1)

eleframe:SetMinMaxValues(0, 100)

eleframe.text = eleframe:CreateFontString(nil,"ARTWORK",nil)
eleframe.text:SetFont([[Interface\Addons\ElementalOverload\PTSansNarrow.ttf]], 15, "OUTLINE")
eleframe.text:SetPoint("CENTER")
eleframe.text:SetJustifyH("MIDDLE")
eleframe.text:SetJustifyV("MIDDLE")

eleframe.text:SetTextColor(1,1,1,1)

eleframe:RegisterEvent("PLAYER_ENTERING_WORLD")
eleframe:RegisterEvent("BAG_UPDATE")
eleframe:RegisterEvent("ADDON_LOADED")
eleframe:RegisterEvent("CURRENCY_DISPLAY_UPDATE")
eleframe:RegisterEvent("PLAYER_LOGOUT")
eleframe:RegisterEvent("BANK_BAG_SLOT_FLAGS_UPDATED")
eleframe:RegisterEvent("REAGENTBANK_UPDATE")
eleframe:RegisterEvent("BANKFRAME_OPENED")

eleframe:SetMovable(true)
eleframe:EnableMouse(false)
eleframe:SetUserPlaced(true)
eleframe:SetClampedToScreen(true)
eleframe:RegisterForDrag("LeftButton")
eleframe:SetScript("OnDragStart", eleframe.StartMoving)
eleframe:SetScript("OnDragStop", eleframe.StopMovingOrSizing)


eleframe:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then
		ElementalOverload:ShowOverload(self)
	end

	if event == "BAG_UPDATE" then
		ElementalOverload:ShowOverload(self)
	end   

	if event == "BANK_BAG_SLOT_FLAGS_UPDATED" then
		ElementalOverload:ShowOverload(self)
	end

	if event == "BANKFRAME_OPENED" then
		ElementalOverload:ShowOverload(self)
	end

	if event == "REAGENTBANK_UPDATE" then
		ElementalOverload:ShowOverload(self)
	end

	if event == "CURRENCY_DISPLAY_UPDATE" then
		ElementalOverload:ShowOverload(self)
	end

	if event == "PLAYER_LOGOUT" then
		ElementalOverload.apenabled = 0
	end

	if event == "ADDON_LOADED" then
		if ElementalOverloadEnabled == nil then
			ElementalOverloadEnabled = 1
		else
			ElementalOverload.apenabled = ElementalOverloadEnabled
			ElementalOverload:ShowOverload(self)
		end
	end
end);

local function ElementalOverloadCommands(msg, editbox)
	if msg == "off" then
		ElementalOverload.apenabled = 0
		ElementalOverloadEnabled = 0
	  	eleframe:Hide()
		print("|cFF0000FFElemental Overload|cFFFFFFFF: Disabled!")
	elseif msg == "on" then
		ElementalOverload.apenabled = 1
		ElementalOverloadEnabled = 1
	  	eleframe:Show()
		print("|cFF0000FFElemental Overload|cFFFFFFFF: Enabled!");
	elseif msg == "lock" then
		eleframe:EnableMouse(false)
		ElementalOverload.aplocked = 1
		print("|cFF0000FFElemental Overload|cFFFFFFFF: Frame is now locked!");
	elseif msg == "unlock" then
		ElementalOverload.aplocked = 0
		eleframe:EnableMouse(true)
		print("|cFF0000FFElemental Overload|cFFFFFFFF: Frame is now unlocked!");
	else
		print("|cFF0000FFElemental Overload|cFFFFFFFF: Syntax: /elo (off|on) (lock|unlock)");
	end 
end
  
SLASH_INAELEMENTALOVERLOAD1 = '/elo'

SlashCmdList["INAELEMENTALOVERLOAD"] = ElementalOverloadCommands 


function ElementalOverload:OnInitialize()
	-- init databroker
	self.db = LibStub("AceDB-3.0"):New("ElementalOverloadDB", {
	  profile = {
		minimap = {
		  hide = false,
		},
		frame = {
		  point = "CENTER",
		  relativeFrame = nil,
		  relativePoint = "CENTER",
		  ofsx = 0,
		  ofsy = 0,
		  width = 750,
		  height = 400,
		},
	  },
	});
	LibDBIcon:Register("ElementalOverload", SimcLDB, self.db.profile.minimap)
	ElementalOverload:UpdateMinimapButton()

	local spell = GetSpellInfo(390392)

	--ElementalOverload:RegisterChatCommand('elo', 'HandleChatCommand')
	AddonCompartmentFrame:RegisterAddon({
	  text = "ElementalOverload",
	  icon = "Interface\\AddOns\\ElementalOverload\\logo",
	  notCheckable = true,
	  func = function()
		--Simulationcraft:PrintSimcProfile(false, false, false)
	  end,
	})
  end

  function ElementalOverload:UpdateMinimapButton()
	if (self.db.profile.minimap.hide) then
	  LibDBIcon:Hide("ElementalOverload")
	else
	  LibDBIcon:Show("ElementalOverload")
	end
  end

local function createIcons()


	for elename, elementalobject in pairs(elementalItemArray) do

		if elename == nil then
			return
		end

		local rousingicon = GetItemIcon(elementalobject.rousing.id)
		local awakenedicon = GetItemIcon(elementalobject.awakened.id)

		local lframe = CreateFrame("Frame", nil, ElementalOverload.eleframe)
		lframe:SetSize(32, 32)
		--lframe:SetPoint("TOPLEFT", 16,  -56 * (elementalobject.row - 1) - 48)
		lframe:SetPoint("TOPLEFT", 16 + 32 * (elementalobject.row - 1), -32) 

		local rframe = CreateFrame("Frame", nil, ElementalOverload.eleframe)
		rframe:SetSize(32, 32)
		--rframe:SetPoint("TOPLEFT", 32 + 16,  -56 * (elementalobject.row - 1) - 48)
		rframe:SetPoint("TOPLEFT", 16 + 32 * (elementalobject.row - 1), -64)

		local animaimage = lframe:CreateTexture(nil,"BACKGROUND")
		animaimage:SetTexture(rousingicon)
		animaimage:SetSize(32,32)
		animaimage:SetPoint("RIGHT")
		animaimage:SetAlpha(0.6)

		local awakenedframe = rframe:CreateTexture(nil,"BACKGROUND")
		awakenedframe:SetTexture(awakenedicon)
		awakenedframe:SetSize(32,32)
		awakenedframe:SetPoint("RIGHT")
		awakenedframe:SetAlpha(0.6)

		lframe:Show()
		rframe:Show()

		lframe.text = lframe:CreateFontString(nil,"ARTWORK",nil)
		lframe.text:SetFont([[Interface\Addons\ElementalOverload\PTSansNarrow.ttf]], 17, "OUTLINE")
		lframe.text:SetPoint("CENTER")
		lframe.text:SetJustifyH("MIDDLE")
		lframe.text:SetJustifyV("MIDDLE")

		lframe.text:SetTextColor(1,1,1,1)

		rframe.text = rframe:CreateFontString(nil,"ARTWORK",nil)
		rframe.text:SetFont([[Interface\Addons\ElementalOverload\PTSansNarrow.ttf]], 17, "OUTLINE")
		rframe.text:SetPoint("CENTER")
		rframe.text:SetJustifyH("MIDDLE")
		rframe.text:SetJustifyV("MIDDLE")

		rframe.text:SetTextColor(1,1,1,1)

		elementalobject.rousing.frame = lframe
		elementalobject.awakened.frame = rframe

	end

end

createIcons()

-- local hoaframe = CreateFrame("Frame", nil, eleframe)
-- hoaframe:SetSize(32, 32)
-- hoaframe:SetPoint("LEFT", -32, 0)


-- hoaframe:Show()

